require 'json'
#processes the values and returns whether the airconditioning or heater should be active or not
class JSONThermostat
  attr_accessor :current_value, :wanted_value, :range, :unit
  attr_accessor :set_cooler, :set_heater  
  def initialize(testjson)
    parsed        = JSON.parse(testjson)
    @wanted_value = parsed['temperature']
    @range        = parsed['range'] / 2.0
    @unitsetting  = parsed['unit']
  end
#updates the json file with the calculated values
  def update(testjson)
    parsed           = JSON.parse(testjson)
    @current_value   = parsed['temperature']
    @unitmeasurement = parsed['unit']
    unit_controlsetting
    unit_controlmeasurement
    check
  end
#controls whether the temperature is warm, cold or pleasant
  def check
    if @current_value < @wanted_value - @range
      warm
    elsif @current_value > @wanted_value + @range
      cold
    else
      pleasant
    end
  end
#controls whether the given unit is celsius, fahrenheid or kelvin and converts the current value
  def unit_controlmeasurement
    if @unitmeasurement == 'celsius'
    elsif @unitmeasurement == 'fahrenheit'
      @current_value = temp_to_fahrenheit(@current_value)
    elsif @unitmeasurement == 'kelvin'
      @current_value = temp_to_kelvin(@current_value)
    end
  end
#controls whether the given unit is celsius, fahrenheid or kelvin and converts the wanted value and range
  def unit_controlsetting
    if @unitsetting == 'celsius'
    elsif @unitsetting == 'fahrenheit'
      @wanted_value = temp_to_fahrenheit(@wanted_value)
      @range = range / 1.8
    elsif @unitsetting == 'kelvin'
      @wanted_value = temp_to_kelvin(@wanted_value)
    end
  end
#converts celcius to kelvin
  def temp_to_kelvin(value)
    value -= 273.2
    value
  end
#converts celcius to fahrenheit
  def temp_to_fahrenheit(value)
    value = (value - 32.0) / 1.8
    value
  end
#returns json file with inactive cooling and inactive heating
  def pleasant
    JSON.generate(cooling: false, heating: false)
  end
#returns json file with active cooling and inactive heating
  def cold
    JSON.generate(cooling: true, heating: false)
  end
#returns json file with inactive cooling and active heating
  def warm
    JSON.generate(cooling: false, heating: true)
  end
end
